#!/usr/bin/env perl

use warnings;
use strict;
use utf8;
use feature ":5.10";

package AAA;
use Moose::Role;
#override dot => sub { ">@{[ super() ]}<" };
around dot => sub { my $orig = shift; my $self = shift;  warn "A";">@{[ $self->$orig(@_) ]}<" };

package BBB;
use Moose::Role;
override dot => sub { warn "A"; ">@{[ super() ]}<" };
#around dot => sub { my $orig = shift; my $self = shift; ">@{[ $self->$orig(@_) ]}<" };

package CCC;
use Moose::Role;
#override dot => sub { ">@{[ super() ]}<" };
around dot => sub { my $orig = shift; my $self = shift; warn "A"; ">@{[ $self->$orig(@_) ]}<" };

package ZZ;
use Moose;
sub dot { "." }

package ZZZ;
use Moose;
extends qw(ZZ);
with qw(AAA BBB CCC);
#with qw(AAA);
#with qw(BBB);
#with "BBB";


package main;
use feature ":5.10";
say ZZZ->new->dot;
